/*Videregende multivariat liner regression*/
#delimit;
log using E:\workdata\703050\bog.log, text replace;
use "E:\workdata\703050\bog.dta", clear;
keep if year==2008;
gen underweight_g11=1 if (BMI<=13.79)&(female==1)&(age==11);
replace underweight_g11=0 if underweight_g11==.;
gen underweight_g12=1 if (BMI<=14.28)&(female==1)&(age==12);
replace underweight_g12=0 if underweight_g12==.;
gen underweight_g13=1 if (BMI<=14.85)&(female==1)&(age==13);
replace underweight_g13=0 if underweight_g13==.;
gen underweight_g14=1 if (BMI<=15.43)&(female==1)&(age==14);
replace underweight_g14=0 if underweight_g14==.;
gen underweight_b11=1 if (BMI<=13.72)&(female==0)&(age==11);
replace underweight_b11=0 if underweight_b11==.;
gen underweight_b12=1 if (BMI<=14.05)&(female==0)&(age==12);
replace underweight_b12=0 if underweight_b12==.;
gen underweight_b13=1 if (BMI<=14.48)&(female==0)&(age==13);
replace underweight_b13=0 if underweight_b13==.;
gen underweight_b14=1 if (BMI<=15.01)&(female==0)&(age==14);
replace underweight_b14=0 if underweight_b14==.;
#delimit;
gen overweight_g11=1 if (BMI>=20.74)&(female==1)&(age==11);
replace overweight_g11=0 if overweight_g11==.;
gen overweight_g12=1 if (BMI>=21.68)& (female==1)&(age==12);
replace overweight_g12=0 if overweight_g12==.;
gen overweight_g13=1 if (BMI>=22.58)& (female==1)&(age==13);
replace overweight_g13=0 if overweight_g13==.;
gen overweight_g14=1 if (BMI>=23.34)& (female==1)&(age==14);
replace overweight_g14=0 if overweight_g14==.;
gen overweight_b11=1 if (BMI>=20.55)& (female==0)&(age==11);
replace overweight_b11=0 if overweight_b11==.;
gen overweight_b12=1 if (BMI>=21.22)& (female==0)*(age==12);
replace overweight_b12=0 if overweight_b12==.;
gen overweight_b13=1 if (BMI>=21.91)& (female==0)&(age==13);
replace overweight_b13=0 if overweight_b13==.;
gen overweight_b14=1 if (BMI>=22.62)& (female==0)&(age==14);
replace overweight_b14=0 if overweight_b14==.;
#delimit;
gen obesity_g11=1 if (BMI>=25.42)* (female==1)*(age==11);
replace obesity_g11=0 if obesity_g11==.;
gen obesity_g12=1 if (BMI>=26.67)* (female==1)*(age==12);
replace obesity_g12=0 if obesity_g12==.;
gen obesity_g13=1 if (BMI>=27.76)* (female==1)*(age==13);
replace obesity_g13=0 if obesity_g13==.;
gen obesity_g14=1 if (BMI>=28.57)* (female==1)*(age==14);
replace obesity_g14=0 if obesity_g14==.;
gen obesity_b11=1 if (BMI>=25.10)* (female==0)*(age==11);
replace obesity_b11=0 if obesity_b11==.;
gen obesity_b12=1 if (BMI>=26.02)* (female==0)*(age==12);
replace obesity_b12=0 if obesity_b12==.;
gen obesity_b13=1 if (BMI>=26.84)* (female==0)*(age==13);
replace obesity_b13=0 if obesity_b13==.;
gen obesity_b14=1 if (BMI>=27.63)* (female==0)*(age==14);
replace obesity_b14=0 if obesity_b14==.;
#delimit;
gen underweight_g=1 if (underweight_g11==1)| (underweight_g12==1)|(underweight_g13==1)|(underweight_g14==1);
replace underweight_g=0 if underweight_g==.;
gen underweight_b=1 if (underweight_b11==1)| (underweight_b12==1)|(underweight_b13==1)|(underweight_b14==1);
replace underweight_b=0 if underweight_b==.;
gen underweight=1 if (underweight_g11==1)| (underweight_g12==1)|(underweight_g13==1)|(underweight_g14==1)|(underweight_b11==1)| (underweight_b12==1)|(underweight_b13==1)|(underweight_b14==1);
replace underweight=0 if underweight==.;
#delimit;
gen overweight_g=1 if (overweight_g11==1)| (overweight_g12==1)|(overweight_g13==1)|(overweight_g14==1);
replace overweight_g=0 if overweight_g==.;
gen overweight_b=1 if (overweight_b11==1)| (overweight_b12==1)|(overweight_b13==1)|(overweight_b14==1);
replace overweight_b=0 if overweight_b==.;
gen overweight=1 if (overweight_g11==1)|(overweight_g12==1)|(overweight_g13==1)|(overweight_g14==1)|(overweight_b11==1)|(overweight_b12==1)|(overweight_b13==1)|(overweight_g14==1);      
replace overweight=0 if overweight==.;
#delimit;
gen obesity_g=1 if (obesity_g11==1)| (obesity_g12==1)|(obesity_g13==1)|(obesity_g14==1);
replace obesity_g=0 if obesity_g==.;
gen obesity_b=1 if (obesity_b11==1)| (obesity_b12==1)|(obesity_b13==1)|(obesity_b14==1);
replace obesity_b=0 if obesity_b==.;
gen obesity=1 if (obesity_g11==1)|(obesity_g12==1)|(obesity_g13==1)|(obesity_g14==1)|(obesity_b11==1)|(obesity_b12==1)|(obesity_b13==1)|(obesity_g14==1);      
replace obesity=0 if obesity==.;

/*Tabel 1 Sammenhngen mellem brns BMI og lokalomrdets sociokonomiske status*/
#delimit;
su BMI ginboth uddaarm qsplindk uddaar;
gen BMI_s=(BMI-18.4811)/3.2145;
gen ginboth_s=(ginboth-249814.2)/127694.6;
gen uddaarm_s=(uddaarm-13.03403)/2.4079;
gen lokalindk_s=(qsplindk-207847.6)/25580.82;
gen lokaluddaar_s=(uddaar-12.16546)/0.5890;
xi:reg BMI_s ginboth_s;
xi:reg BMI_s uddaarm_s;
xi:reg BMI_s lokalindk_s;
xi:reg BMI_s lokaluddaar_s;
xi: reg BMI_s  lokalindk_s lokaluddaar_s ;
estat vif;
#delimit;
gen ginboth_i=(ginboth)/1661221;
gen uddaarm_i=(uddaarm)/20;
gen lokalindk_i=(qsplindk)/270756.9;
gen lokaluddaar_i=(uddaar)/13.4087;
xi:reg lnBMI ginboth_i;
xi:reg lnBMI uddaarm_i;
xi:reg lnBMI lokalindk_i;
xi:reg lnBMI lokaluddaar_i;
xi: reg lnBMI  lokalindk_i lokaluddaar_i;
corr lokalindk_i lokaluddaar_i;
estat vif; 
  
/* Tabel 2 Sammensat ml*/
#delimit;
gen seslokalt=(lokalindk_i + lokaluddaar_i )/2; 
drop if seslokalt==.;
#delimit;
gen sesfamilie=(ginboth_i+uddaarm_i)/2;
drop if sesfamilie==.;
centile sesfamilie, centile(50);
centile seslokalt, centile(50);
#delimit;
gen dsesfamilie=1 if sesfamili>=0.3967;
replace dsesfamilie=0 if dsesfamilie==.;
gen dseslokalt=1 if seslokalt>=0.8275;
replace dseslokalt=0 if dseslokalt==.;
#delimit;
xi: reg lnBMI  seslokalt;
xi: reg lnBMI  sesfamilie;
xi: reg lnBMI  seslokalt  sesfamilie;

/* Tabel 3 Delgruppeanalyser*/
#delimit;
xi: reg lnBMI  seslokalt if  dsesfamilie==1;
xi: reg lnBMI  seslokalt if  dsesfamilie==0;

/* Tabel 4 Interaktionsleddet*/
#delimit;
gen dint=dseslokalt*dsesfamilie;
gen ndint= seslokalt*dsesfamilie;
gen inter= seslokalt*sesfamilie;
#delimit;
xi: reg lnBMI  dseslokalt  dsesfamilie;
xi: reg lnBMI  dseslokalt dsesfamilie dint;
#delimit;
xi: reg lnBMI  seslokalt  dsesfamilie;
xi: reg lnBMI  seslokalt  dsesfamilie ndint;

/* Tabel 5 Quantile regressions*/
#delimit;
qreg lnBMI seslokalt sesfamilie, quantile(.1);
qreg lnBMI seslokalt sesfamilie, quantile(.2);
qreg lnBMI seslokalt sesfamilie, quantile(.3);
qreg lnBMI seslokalt sesfamilie, quantile(.4);
qreg lnBMI seslokalt sesfamilie, quantile(.5);
qreg lnBMI seslokalt sesfamilie, quantile(.6);
qreg lnBMI seslokalt sesfamilie, quantile(.7);
qreg lnBMI seslokalt sesfamilie, quantile(.8);
qreg lnBMI seslokalt sesfamilie, quantile(.9);

/* Tabel 6 Cutting points afhngige variabel*/
#delimit;
xi: reg underweight  seslokalt  sesfamilie;
xi: reg overweight  seslokalt  sesfamilie;
xi: reg obesity seslokalt  sesfamilie;

/* Tabel 7 Cutting points uafhngige variabler*/
#delimit;
centile seslokalt , centile(25);
centile seslokalt , centile(75);
centile sesfamilie , centile(25);
centile sesfamilie , centile(75);
#delimit;
gen seslokalt_25=1 if seslokalt<=0.7896; 
replace seslokalt_25=0 if seslokalt_25==.;
gen seslokalt_75=1 if seslokalt>0.8703; 
replace seslokalt_75=0 if seslokalt_75==.;
#delimit;
gen sesfamilie_25=1 if sesfamilie<=0.3566; 
replace sesfamilie_25=0 if sesfamilie_25==.;
gen sesfamilie_75=1 if sesfamilie>0.4493; 
replace sesfamilie_75=0 if sesfamilie_75==.;
#delimit;
gen dinter_25=(seslokalt_25*sesfamilie_25);
gen dinter_75=(seslokalt_75*sesfamilie_75);
#delimit;
xi: reg lnBMI  seslokalt_25 sesfamilie_25 dinter_25, robust;
xi: reg lnBMI  seslokalt sesfamilie dint, robust;
xi: reg lnBMI  seslokalt_75 sesfamilie_75 dinter_75, robust;

/*Test for Heteroskedasticitet*/
#delimit;
xi: reg lnBMI  dseslokalt  dsesfamilie;
estat hettest;
estat imtest, white;
xi: reg lnBMI  dseslokalt  dsesfamilie dint;
estat hettest;
estat imtest, white;
#delimit;
xi: reg lnBMI  seslokalt  dsesfamilie;
estat hettest;
estat imtest, white;
xi: reg lnBMI  seslokalt  dsesfamilie ndint;
estat hettest;
estat imtest, white;

/* Tabel 8 Robuste standardfejl */
#delimit;
xi: reg lnBMI  seslokalt  sesfamilie inter;
xi: reg lnBMI  seslokalt  sesfamilie inter, robust;
xi: reg lnBMI   seslokalt  sesfamilie inter, cluster (school);
#delimit;
xi: reg lnBMI  dseslokalt  dsesfamilie dint;
xi: reg lnBMI  dseslokalt  dsesfamilie dint, robust;
xi: reg lnBMI  dseslokalt  dsesfamilie dint, cluster (school);
log close;
